package jp.gihyo.spring.mvc;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("java")
public class JavaController {
    private SampleConfiguration sampleConfiguration;

    @Autowired
    public JavaController(SampleConfiguration sampleConfiguration) {
        this.sampleConfiguration = sampleConfiguration;
    }

    @GetMapping("hello")
    @ResponseBody
    public String hello(
            // 01 Kotlin と Spring Framework
            // 04 Spring の null安全対応
            // 01 リクエストパラメータ
            @RequestParam String name,
            @RequestParam(required = false) String voice
    ) {
        if (voice == null) voice = "Hello";
        return voice + " " + name;
    }

    // 01 Kotlin と Spring Framework
    // 04 Spring の null安全対応
    // 03 Model のキーアクセス
    @GetMapping
    public String index(Model model) {
        model.addAttribute("key", "value");
        return "index";
    }

    @GetMapping("sample")
    @ResponseBody
    public String sample() {
        return sampleConfiguration.value;
    }
}
