package jp.gihyo.spring.webflux

import com.fasterxml.jackson.databind.PropertyNamingStrategy
import org.springframework.boot.Banner
import org.springframework.boot.autoconfigure.SpringBootApplication
import org.springframework.boot.runApplication
import org.springframework.context.support.beans
import org.springframework.http.converter.json.Jackson2ObjectMapperBuilder

@SpringBootApplication
class Application

fun main(args: Array<String>) {
    runApplication<Application>(*args) {
        setBannerMode(Banner.Mode.OFF)

        addInitializers(
            beans {
                bean {
                    Jackson2ObjectMapperBuilder()
                        .propertyNamingStrategy(
                            PropertyNamingStrategy
                                .SNAKE_CASE
                        )
                }
            }
        )
    }
}