package jp.gihyo.spring.webflux

import org.springframework.http.MediaType
import org.springframework.stereotype.Component
import org.springframework.web.reactive.function.BodyInserters
import org.springframework.web.reactive.function.server.ServerRequest
import org.springframework.web.reactive.function.server.ServerResponse
import reactor.core.publisher.Mono
import java.util.*

@Component
class LessonHandler(
    private val lessonRepository: LessonRepository
) {
  fun findByDate(request: ServerRequest): Mono<ServerResponse> {
      val date = LessonRepository.formatter
          .parse(request.pathVariable("date"))
      return ServerResponse.ok()
          .contentType(MediaType.APPLICATION_JSON)
          .body(BodyInserters.fromObject(lessonRepository.findByDate(date)))
  }
}