package jp.gihyo.spring.webflux

import org.springframework.http.MediaType
import org.springframework.stereotype.Component
import org.springframework.web.reactive.function.BodyInserters
import org.springframework.web.reactive.function.server.ServerRequest
import org.springframework.web.reactive.function.server.ServerResponse
import reactor.core.publisher.Mono

@Component
class MemberHandler(
    val memberRepository: MemberRepository
) {
    fun findAll(request: ServerRequest): Mono<ServerResponse> {
        val memberList = memberRepository.findAll()
        return ServerResponse.ok()
            .contentType(MediaType.APPLICATION_JSON)
            .body(BodyInserters.fromObject(memberList))
    }

    fun findOne(request: ServerRequest): Mono<ServerResponse> {
        val id = request.pathVariable("id").toLong()
        return ServerResponse.ok()
            .contentType(MediaType.APPLICATION_JSON)
            .body(BodyInserters.fromObject(memberRepository.findOne(id)))
    }
}