package jp.gihyo.spring.webflux

import org.springframework.context.annotation.Bean
import org.springframework.context.annotation.Configuration
import org.springframework.http.MediaType
import org.springframework.web.reactive.function.server.router

@Configuration
class Router(
    private val memberHandler: MemberHandler,
    private val lessonHandler: LessonHandler
) {
    // 01 Kotlin と Spring Framework
    // 03 Kotlin DSL の導入
    // 02 Bean 定義
    @Bean
    fun apiRouter() = router {
        (accept(MediaType.APPLICATION_JSON) and "/api")
            .nest {
                "/member".nest {
                    GET("/", memberHandler::findAll)
                    GET("/{id}", memberHandler::findOne)
                }
                "/lesson".nest {
                    GET(
                        "/{date}",
                        lessonHandler::findByDate
                    )
                }
            }
    }
}