package jp.gihyo.test.kotlintest.spring

import io.kotlintest.*
import io.kotlintest.specs.*
import io.kotlintest.spring.*
import jp.gihyo.test.kotlintest.spring.service.*
import org.springframework.beans.factory.annotation.*
import org.springframework.context.annotation.*
import org.springframework.test.context.*

@ComponentScan // DI コンテナに登録
class TestConfiguration

@ContextConfiguration(classes = [(TestConfiguration::class)])
class AccountControllerTest : AnnotationSpec() {

    // KotlinTest でフィールド インジェクションを有効化
    override fun listeners() = listOf(SpringListener)

    @Autowired // アノテーションによるフィールド インジェクション
    private lateinit var accountService: AccountService

    @Test
    fun `@Autowired フィールド インジェクション`() {
        accountService.findById(1).name should be("nameless")
    }
}