package jp.gihyo.test.mockitokotlin

import com.nhaarman.mockitokotlin2.*
import org.junit.*
import org.junit.Assert.*
import org.junit.runner.*
import org.mockito.*
import org.mockito.junit.*

@RunWith(MockitoJUnitRunner::class)
class ArgumentCaptorTest {
    @Mock
    private lateinit var accountRepository: AccountRepository

    @InjectMocks
    private lateinit var accountService: AccountServiceImpl

    @Test
    fun `Given name "Alice" When create Then name "ALICE"`() {
        accountService.create(Account("Alice"))

        // 型パラメータにキャプチャしたい引数の型を指定
        argumentCaptor<Account>().apply {
            verify(accountRepository).insert(capture())  // 引数をキャプチャ
            assertEquals("ALICE", firstValue.name) // キャプチャした値を取り出す
        }
    }
}
