package jp.gihyo.test.mockitokotlin

import com.nhaarman.mockitokotlin2.*
import org.junit.*
import org.junit.Assert.*

class MockitoKotlinTest {
    @Test
    fun testCreateAccount() {
        // arrange
        val accountRepository: AccountRepository = mock {
            on { insert(any()) }.thenReturn(Account("Mocked!"))
        }
        val accountService = AccountServiceImpl(accountRepository)
        // act
        val actual = accountService.create(Account())
        // assert
        assertEquals("Mocked!", actual.name)
    }
}
