package jp.gihyo.test.mockitokotlin

import com.nhaarman.mockitokotlin2.*
import org.junit.*
import org.junit.Assert.*
import org.junit.runner.*
import org.mockito.*
import org.mockito.junit.*

@RunWith(MockitoJUnitRunner.StrictStubs::class)
class UnnecessaryStubbingExceptionTest {
    @Mock
    private lateinit var accountRepository: AccountRepository

    @InjectMocks
    private lateinit var accountService: AccountServiceImpl

    @Test
    fun `Given id 1 When findById Then "Alice"`() {
        whenever(accountRepository.findById(1)).thenReturn(Account("Alice"))
        assertEquals("Alice", accountService.findById(1).name)
    }

    @Test
    fun `Given id 2 When findById Then "Bob"`() {
        whenever(accountRepository.findById(2)).thenReturn(Account("Bob")) // 未使用のスタブ
        //assertEquals("bob", accountService.findById(2).name)
    }
}