package jp.gihyo.test.mockitokotlin

import com.nhaarman.mockitokotlin2.*
import org.junit.*
import org.junit.runner.*
import org.mockito.*
import org.mockito.junit.*

@RunWith(MockitoJUnitRunner::class)
class VerifyTest {
    @Mock
    private lateinit var accountRepository: AccountRepository

    @InjectMocks
    private lateinit var accountService: AccountServiceImpl

    @Test
    fun `Given name When findByName Then call by upper case`() {
        accountService.findByName("Alice")
        accountService.findByName("Bob")
        accountService.findByName("Alice")
        verify(accountRepository, times(2)).findByName("ALICE")
        verify(accountRepository).findByName("BOB") // times(1) がデフォルト設定される
    }
}