package jp.gihyo.test.mockito

class Account(val name: String = "nameless")

open class AccountRepository {
    open fun findById(id: Int) = Account()
    open fun findByName(name: String) = Account(name)
    open fun insert(account: Account) = Account(account.name)
}

// コンストラクタで AccountRepository を挿入
open class AccountServiceImpl(val accountRepository: AccountRepository) {
    fun findById(id: Int) = accountRepository.findById(id)
    fun findByName(name: String) = accountRepository.findByName(name.toUpperCase())
    fun create(account: Account): Account {
        val newAccount = Account(account.name.toUpperCase())
        return accountRepository.insert(newAccount)
    }
}