package jp.gihyo.test.mockito

import org.junit.*
import org.junit.Assert.*
import org.junit.runner.*
import org.mockito.*
import org.mockito.Mockito.*
import org.mockito.junit.*

@RunWith(MockitoJUnitRunner::class)
class ArgumentCaptorTest {
    @Mock
    private lateinit var accountRepository: AccountRepository

    @InjectMocks
    private lateinit var accountService: AccountServiceImpl

    @Test
    fun `Given account "Alice" When update Then call by "Alice"`() {
        accountService.create(Account("Alice"))

        val argumentCaptor = ArgumentCaptor.forClass(Account::class.java)
        verify(accountRepository, times(1)).insert(argumentCaptor.capture())
        assertEquals("Alice", argumentCaptor.value.name)
    }
}
